unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AppEvnts, StdCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ApplicationEvents1: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  Proceed: Boolean = False;
  UseDebug: Boolean = False;

implementation

Uses LPL_Message;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
Begin
 If uppercase(ParamStr(1)) = '/DEBUG' Then Begin // If the first parameter is "/Debug" then
		 	                         // Start the debugger initialisation.
  Proceed := True;	// This variable has to be declared Globally
  Dial('TMainForm', 'Test Program', 'Test Application'); // Dial the debugger.
  Repeat
   Application.ProcessMessages;	// Process incoming messages.
  Until (Proceed);	// When Proceed is true continue.
 End;
 If Usedebug Then SendToDebug('Programming is Running'); // Make the debugger show that
  					                 // the program is running.
End;

procedure TMainForm.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
Begin
 If Msg.Message <> LPL_TypeCast Then Begin // If The message isn't a LPL_Typecast
  Handled := False; // The message isn't handled
 End
  Else
 Begin // If the message is a LPl_TypeCast
  Handled := True; // Message Is handled
  If Msg.wParam = LPL_DEBUG_CALLBACK Then begin // This line occurs when the
   			                        // debugger sends it "ready-for-
						// use" respond.
   If Msg.lParam = LPL_DEBUG_CALLBACK_GOAHEAD Then Begin // Ready
    UseDebug := True; // Application is in debug state
    Proceed := true; // Unlock application and proceed
   End;
   If Msg.lParam = LPL_DEBUG_CALLBACK_BUSY Then begin // Busy
    UseDebug := False; // Application isn't in debug state
    Proceed := True; // Unlock application and proceed
   End;
  End;
  If Msg.wParam = LPL_TC_DEBUG_SHUTDOWN then Begin // Debugger has been
                  				   // Shutdown.
   Application.Messagebox(PChar('Debugger has been terminated'), PChar('Can Not Debug'), 0); // Alert the user of the shutdown.
   UseDebug := False; // Since we can't display debug messages changes the Debug state to
		      // Increase program speed.
  End;
 End;
End;

procedure TMainForm.Button1Click(Sender: TObject);
begin
 If UseDebug Then SendToDebug('Button1 Clicked');
 Showmessage('Thank you for using LPL Debugger');
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
 If UseDebug then SendToDebug('Button2 Clicked');
 Showmessage('LPL Debugger is a cool utility');
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
 If UseDebug Then SendToDebug('Terminate Application');
 If UseDebug Then FreeDebug;
 Application.Terminate;
end;

end.
